//
//  RapidBitalino.h
//  Bitalino
//
//  Created by James on 20/11/2017.
//
//

#ifndef RapidBitalino_h
#define RapidBitalino_h

#include "ofMain.h"
#include "rapidmix.h"
#include "RapidMixThread.h"
#include "BitalinoThread.h"
#include "maxiFFT.h"

typedef rapidmix::staticRegression selectedTraining;

class RapidBitalino {
public:
    RapidBitalino ( void );
    ~RapidBitalino ( void );
    
    void clearTrainingData ( void );
    void recordTrainingData ( uint32_t numberOfSamplesToCollect, double output );
    void setup ( void );
    
    void update ( void );
    void draw ( void );
    
    void stop ( void );
    
private:
    // Private member funcs
    bool processBitalinoOutput(BITalino::Frame& frame);
    
    // Private variables
    std::string trainingText = "idle";
    
    // Rapid Mix stuff
    rapidmix::trainingData trainingData;
    std::vector<rapidmix::trainingData::phrase>::iterator currentPhrase;
    
    // My own stuff
    uint32_t samplesToCollect;
    std::vector<double> currentTrainingOutput;
    
    RapidMixThread<selectedTraining> rapidMixThread;
    BitalinoThread bitalinoThread;
    
    bool gatheringTrainingData = false;
    
    // Processing the BITalino output
    maxiFFT fft;
    double discreteVal = 0;
    double discreteValCalibrated = 0;
    double N = 1000;
    double M = 100;
    
    double testCheapRMSdiscrete = 0;
    
    double tOutput = 0.0;
    
    std::vector<double> bitalinoProcessedOutput;
};


#endif /* RapidBitalino_h */
